var roles = require("./../lib/roles"),
    contacts_app = roles.addApplication("contacts").addRoles("view", "create", "change"),
    admin_prof = roles.addProfile("admin").addRoles("contacts.*"),
    guest_prof = roles.addProfile("guest").addRoles("contacts.view");

roles.getMonitor().on("role.invalid", function (app, role) {
	console.log("Monitor: invalid role '%s' on app '%s'", role, app);
}).on("app.addrole", function (app, role) {
	console.log("Application: %s // Added role: '%s'", app, role);
}).on("app.delrole", function (app, role) {
	console.log("Application: %s // Deleted role: '%s'", app, role);
}).on("profile.addrole", function (profile, app, role) {
	console.log("Profile: %s // Added application role: %s.%s", profile, app, role);
}).on("profile.delrole", function (profile, app, role) {
	console.log("Profile: %s // Deleted application role: %s.%s", profile, app, role);
});

contacts_app.addRoles("list").removeRoles("view");
guest_prof.addRoles("contacts.list", "contacts.add");

var test_roles = [ "contacts.view", "contacts.change", "contacts.list", "contacts.*", "contacts.remove" ];

console.log("");

for (var i = 0; i < test_roles.length; i++) {
	console.log(test_roles[i] + "\n--------------");
	console.log("- admin profile %s", admin_prof.hasRoles(test_roles[i]) ? "has" : "does not have");
	console.log("- guest profile %s", guest_prof.hasRoles(test_roles[i]) ? "has" : "does not have");
	console.log("");
}

contacts_app.addRoles("remove");
guest_prof.removeRoles("contacts.list");

test_roles = [ "contacts.list", "contacts.*", "contacts.remove", "contacts.view" ];

console.log("-----------------------\n");

for (var i = 0; i < test_roles.length; i++) {
	console.log(test_roles[i] + "\n--------------");
	console.log("- admin profile %s", admin_prof.hasRoles(test_roles[i]) ? "has" : "does not have");
	console.log("- guest profile %s", guest_prof.hasRoles(test_roles[i]) ? "has" : "does not have");
	console.log("");
}

console.log(roles.export());
roles.import(roles.export());
console.log(roles.export());